'use strict';

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

require('babel-polyfill');

var isFunction = function isFunction(val) {
  return typeof val === 'function';
};
var isPromise = function isPromise(val) {
  return val.then && isFunction(val.then);
};

function wrapper(generator) {
  var iterator = generator();

  // eslint-disable-next-line no-use-before-define
  var loopNext = function loopNext(val) {
    return handleReturned(iterator.next(val));
  };
  // eslint-disable-next-line no-use-before-define
  var loopError = function loopError(val) {
    return handleReturned(iterator.throw(val));
  };

  function handleReturned(returned) {
    if (!returned.done) {
      try {
        (function () {
          var value = isFunction(returned.value) ? returned.value() : returned.value;

          if (isPromise(value)) {
            value.then(loopNext, loopError);
          } else {
            process.nextTick(function () {
              loopNext(value);
            });
          }
        })();
      } catch (e) {
        loopError(e);
      }
    }
  }

  loopNext();
}

function fallback(sources) {
  return new Promise(function (resolve, reject) {
    wrapper(regeneratorRuntime.mark(function g() {
      var lastError, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, source;

      return regeneratorRuntime.wrap(function g$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              lastError = void 0;
              // eslint-disable-next-line no-restricted-syntax

              _iteratorNormalCompletion = true;
              _didIteratorError = false;
              _iteratorError = undefined;
              _context.prev = 4;
              _iterator = sources[Symbol.iterator]();

            case 6:
              if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                _context.next = 22;
                break;
              }

              source = _step.value;
              _context.prev = 8;
              _context.t0 = resolve;
              _context.next = 12;
              return source;

            case 12:
              _context.t1 = _context.sent;
              return _context.abrupt('return', (0, _context.t0)(_context.t1));

            case 16:
              _context.prev = 16;
              _context.t2 = _context['catch'](8);

              lastError = _context.t2;

            case 19:
              _iteratorNormalCompletion = true;
              _context.next = 6;
              break;

            case 22:
              _context.next = 28;
              break;

            case 24:
              _context.prev = 24;
              _context.t3 = _context['catch'](4);
              _didIteratorError = true;
              _iteratorError = _context.t3;

            case 28:
              _context.prev = 28;
              _context.prev = 29;

              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }

            case 31:
              _context.prev = 31;

              if (!_didIteratorError) {
                _context.next = 34;
                break;
              }

              throw _iteratorError;

            case 34:
              return _context.finish(31);

            case 35:
              return _context.finish(28);

            case 36:
              return _context.abrupt('return', reject(lastError));

            case 37:
            case 'end':
              return _context.stop();
          }
        }
      }, g, this, [[4, 24, 28, 36], [8, 16], [29,, 31, 35]]);
    }));
  });
}

var sourceReplicator = regeneratorRuntime.mark(function sourceGenerator(val, times) {
  var countdown, infinite;
  return regeneratorRuntime.wrap(function sourceGenerator$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          countdown = times;
          infinite = times === 0;

        case 2:
          if (!(infinite || countdown > 0)) {
            _context2.next = 8;
            break;
          }

          _context2.next = 5;
          return val;

        case 5:
          countdown -= 1;
          _context2.next = 2;
          break;

        case 8:
        case 'end':
          return _context2.stop();
      }
    }
  }, sourceGenerator, this);
});

var cycleGenerator = regeneratorRuntime.mark(function cycleGenerator(parameters, func) {
  var i;
  return regeneratorRuntime.wrap(function cycleGenerator$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          i = 0;

        case 1:
          if (!(i < parameters.length)) {
            _context3.next = 7;
            break;
          }

          _context3.next = 4;
          return func.apply(undefined, _toConsumableArray(parameters[i]));

        case 4:
          i += 1;
          _context3.next = 1;
          break;

        case 7:
        case 'end':
          return _context3.stop();
      }
    }
  }, cycleGenerator, this);
});

module.exports = {
  fallback: fallback,

  retry: function retry(source) {
    var times = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

    return fallback(sourceReplicator(source, times));
  },
  cycle: function cycle(parameters, func) {
    return fallback(cycleGenerator(parameters, func));
  }
};